
local headsel = cssfilter("head")
local headersel = cssfilter("header.post__header")

local articlesels = {
	cssfilter("article"),
	cssfilter("div#main"),
	cssfilter("#main-article"),
	cssfilter(".main-content"),
	cssfilter("#body"),
	cssfilter("#content"),
	cssfilter(".content"),
	cssfilter("div#article"),
	cssfilter("div.article"),
	cssfilter("div.post-outer"),
	cssfilter(".l-root"),
	cssfilter(".content-container"),
}
local annoyances = {
	cssfilter("div.zipr-recirc"),
	cssfilter("section#news-feed"),
	cssfilter("div#comments"),
	cssfilter(".visually-hidden"),
	cssfilter(".newsletter-signup"),
}

function shouldfilter(host)
	if host:match("github.com") then return "" end
	if host:match("amazon.com") then return "" end
	if host:match("twitter.com") then return "" end
	if host:match("cdn.googlesource.com") then return "" end
	return "yeah"
end

function prefilter(req)
	local host = reqgethost(req)
	host = host:gsub("www.reddit.com", "old.reddit.com")
	reqsethost(req, host)
end

function filter(outw, req, host, path, root)
	print("trying to filter in lua", host, path)
	if path == "/" then
		return ""
	end
	local article
	for i = 1, #articlesels do
		article = matchall(root, articlesels[i])
		if #article == 1 then
			break
		end
	end
	if #article ~= 1 then
		print("didn't find anything to grab")
		return ""
	end
	article = article[1]

	writestring(outw, prolog)
	local head = matchfirst(root, headsel)
	if head then
		clean(outw, head, req)
	end
	writestring(outw, "</head>\n<body>\n")
	local header = matchfirst(root, headersel)
	if header then
		clean(outw, header, req)
	end
	if host == "www.washingtonpost.com" then
		local headlinesel = cssfilter("#topper-headline-wrapper")
		local headline = matchfirst(root, headlinesel)
		if headline then
			clean(outw, headline, req)
		end
	end
	if host:match("blogspot") then
		article = root
	end
	if host:match("livejournal") then
		local sel = cssfilter("div.box")
		local entries = matchall(article, sel)
		for i = 2, #entries do
			removenode(entries[i])
		end
	end
	for i = 1, #annoyances do
		local bad = matchfirst(article, annoyances[i])
		if bad then
			removenode(bad)
		end
	end

	clean(outw, article, req)
	print("i did it, i cleaned it")
	return "cleaned"
end

prolog = [==[
<!doctype html>
<html>
<head>
<meta charset="utf-8">
<style>
body {
	max-width: 940px;
	margin: auto;
	font-size: 1.4em;
	line-height: 1.5;
}
img {
	max-width: 900px;
}
pre {
	white-space: pre-wrap;
	word-wrap: break-word;
}
</style>
]==]
